Getting Started with Validator Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the Validator module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.validator.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smartValidator id="validator"></smartValidator>

    Host container (id matches appendTo on Smart.Validator):

    <div id="validatorContainer"></div>

  5. Initialize after the module loads: define a const validatorOptions object, then either bind with Smart('#validator', ...) on the semantic tag or use new Smart.Validator({ ...validatorOptions, appendTo: '#validatorContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.validator.js';
    
    	const validatorOptions = {};
    
    	// Option A - semantic <smartValidator> with id="validator"
    	Smart('#validator', class {
    		get properties() {
    			return validatorOptions;
    		}
    	});
    
    	// Option B - host div id="validatorContainer"
    	// const validatorInstance = new Smart.Validator({
    	// 	...validatorOptions,
    	// 	appendTo: '#validatorContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myValidator = new Smart.Validator('#validator', validatorOptions);
    	// document.body.appendChild(myValidator);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.Validator('#validator', validatorOptions) with appendChild, and document.createElement('smartValidator') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.Validator({ ...options, appendTo: '#...' }); new Smart.Validator('#validator', validatorOptions) plus appendChild on the returned element; and document.createElement('smartValidator') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myValidator = new Smart.Validator('#validator', validatorOptions)):

	const validatorOptions = {};
	const myValidator = new Smart.Validator('#validator', validatorOptions);
	document.body.appendChild(myValidator);
	

Create with document.createElement('smartValidator'), assign properties (same as any custom element), then append:

	const validatorOptions = {};
	const validator = document.createElement('smartValidator');
	Object.assign(validator, validatorOptions);
	document.body.appendChild(validator);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.validator.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const validatorOptions = {};
		const validator = new Smart.Validator({
			...validatorOptions,
			appendTo: '#validatorContainer'
		});
	}
	

Append to the DOM:

const container = document.getElementById('validator-container');
container.appendChild(validator);
	

Remove from the DOM:

validator.remove();
	

Set a property:

validator.disabled = true;
validator.theme = 'dark';
	

Get a property value:

const isDisabled = validator.disabled;
const currentTheme = validator.theme;
	

Invoke a method:

validator.refresh();
validator.focus();
	

Add event listener:

validator.addEventListener('change', (event) => {
    console.log('Event triggered:', event.detail);
});
	

Remove event listener:

const handleValidatorEvent = (event) => {
    console.log('Event triggered:', event.detail);
};

validator.addEventListener('change', handleValidatorEvent);
validator.removeEventListener('change', handleValidatorEvent);
	

Accessibility

The Validator component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Validator - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/validator/overview

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import ValidatorModule from smart-webcomponents-angular/validator: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { ValidatorModule } from 'smart-webcomponents-angular/validator';

4 Root component (standalone)

Add ValidatorModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { Smart } from 'smart-webcomponents-angular/validator';
import { ButtonComponent } from 'smart-webcomponents-angular/button';
import { CheckBoxComponent } from 'smart-webcomponents-angular/checkbox';
import { DateTimePickerComponent } from 'smart-webcomponents-angular/datetimepicker';
import { DropDownListComponent } from 'smart-webcomponents-angular/dropdownlist';
import { MaskedTextBoxComponent } from 'smart-webcomponents-angular/maskedtextbox';
import { NumericTextBoxComponent } from 'smart-webcomponents-angular/numerictextbox';
import { PasswordTextBoxComponent, PasswordTextBox } from 'smart-webcomponents-angular/passwordtextbox';
import { TextBoxComponent } from 'smart-webcomponents-angular/textbox';

import { ButtonModule } from 'smart-webcomponents-angular/button';

import { CheckBoxModule } from 'smart-webcomponents-angular/checkbox';

import { DateTimePickerModule } from 'smart-webcomponents-angular/datetimepicker';

import { DropDownListModule } from 'smart-webcomponents-angular/dropdownlist';

import { MaskedTextBoxModule } from 'smart-webcomponents-angular/maskedtextbox';

import { NumericTextBoxModule } from 'smart-webcomponents-angular/numerictextbox';

import { PasswordTextBoxModule } from 'smart-webcomponents-angular/passwordtextbox';

import { TextBoxModule } from 'smart-webcomponents-angular/textbox';

import { ValidatorModule } from 'smart-webcomponents-angular/validator';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ ButtonModule, CheckBoxModule, DateTimePickerModule, DropDownListModule, MaskedTextBoxModule, NumericTextBoxModule, PasswordTextBoxModule, TextBoxModule, ValidatorModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {
    @ViewChild('button', { read: ButtonComponent, static: false }) button!: ButtonComponent;
    @ViewChild('checkbox', { read: CheckBoxComponent, static: false }) checkbox!: CheckBoxComponent;
    @ViewChild('datetimepicker', { read: DateTimePickerComponent, static: false }) datetimepicker!: DateTimePickerComponent;
    @ViewChild('dropdownlist', { read: DropDownListComponent, static: false }) dropdownlist!: DropDownListComponent;
    @ViewChild('maskedtextbox', { read: MaskedTextBoxComponent, static: false }) maskedtextbox!: MaskedTextBoxComponent;
    @ViewChild('numerictextbox', { read: NumericTextBoxComponent, static: false }) numerictextbox!: NumericTextBoxComponent;
    @ViewChild('passwordtextbox', { read: PasswordTextBoxComponent, static: false }) passwordtextbox!: PasswordTextBoxComponent;
    @ViewChild('passwordtextbox2', { read: PasswordTextBoxComponent, static: false }) passwordtextbox2!: PasswordTextBoxComponent;
    @ViewChild('textbox', { read: TextBoxComponent, static: false }) textbox!: TextBoxComponent;
    @ViewChild('textbox2', { read: TextBoxComponent, static: false }) textbox2!: TextBoxComponent;
    @ViewChild('textbox3', { read: TextBoxComponent, static: false }) textbox3!: TextBoxComponent;
    @ViewChild('textbox4', { read: TextBoxComponent, static: false }) textbox4!: TextBoxComponent;


    ngOnInit(): void {
        // onInit code.
    }

    ngAfterViewInit(): void {
        // afterViewInit code.
        this.init();
    }

    init(): void {
        // init code.


        'use strict';
        let maxDate = new Date();
        maxDate.setFullYear(2025);
        const rules = [
            //Email
            { input: '#email-validation', message: 'E-mail is required', action: 'keyup, blur', type: 'required' },
            { input: '#email-validation', message: 'Email is invalid', action: 'keyup', type: 'email' },
            //Password
            { input: '#password-validation', message: 'Password is required!', action: 'keyup, blur', type: 'required' },
            //Confirm password
            { input: '#confirm-password-validation', message: 'Confirm Password is required!', action: 'keyup, blur', type: 'required' },
            {
                input: '#confirm-password-validation', message: '\'Password\' and \'Confirm Password\' do not match.', action: 'keyup, blur', type: 'compare',
                comparisonTarget: function () {
                    let password = document.querySelector('#password-validation') as any;
                    if (password) {
                        return password.value;
                    }
                },
            },
            //Name
            { input: '#name-validation', message: 'Name is required!', action: 'keyup, blur', type: 'required' },
            { input: '#name-validation', message: 'Do not use digits in the Name.', action: 'keyup, blur', type: 'pattern', pattern: /^[^0-9]+$/ },
            { input: '#name-validation', message: 'Name must have at least 2 symbols', action: 'keyup, blur', type: 'stringLength', min: 2 },
            //Date
            //{ input: '#date-validation', message: 'Date of birth is required', action: 'change', type: 'required' },
            { input: '#date-validation', message: 'You must be at least 21 years old', action: 'change', type: 'range', max: maxDate, },
            //Country
            { input: '#country-validation', message: 'Country is required', action: 'change', type: 'required' },
            //City
            { input: '#city-validation', message: 'City is required', action: 'keyup, blur', type: 'required' },
            { input: '#city-validation', message: 'Do not use digits in the City name.', action: 'keyup, blur', type: 'pattern', pattern: /^[^0-9]+$/ },
            { input: '#city-validation', message: 'City must have at least 2 symbols', action: 'keyup, blur', type: 'stringLength', min: 2 },
            //Address
            { input: '#address-validation', message: 'Address is required', action: 'keyup, blur', type: 'required' },
            //Phone
            { input: '#phone-validation', message: 'The phone must have a correct USA phone format', action: 'valuechanged, blur', type: 'pattern', pattern: /^\+\s*1\s*\(\s*[02-9]\d{2}\)\s*\d{3}\s*-\s*\d{4}$/ },
            //Post  code
            { input: '#post-code-validation', message: 'The post code must contains only digits', action: 'change', type: 'numeric' },
            { input: '#post-code-validation', message: 'The post code must have at least 4 symbols', action: 'change', type: 'stringLength', min: 4 },
            //Terms
            { input: '#termsInput', message: 'You must agree to the Terms and Conditions', action: 'change', type: 'required', },
        ];
        //SmartValidator
        const validator = new Smart.Utilities.Validator(rules, '#validationsummary');
        document.querySelector('#register')?.addEventListener('click', () => {
            validator.validate();
        });


    }
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smartValidator as needed:

 <div class="demo-container">
    <form id="testForm" action="./">
        <div class="fieldset">
            <div class="fieldset-header">Credentials</div>
            <div class="field">
                <div class="field-label">Email</div>
                <div class="field-value">
                    <smart-text-box #textbox select-all-on-focus placeholder="Email" id="email-validation"></smart-text-box>
                </div>
            </div>
            <div class="field">
                <div class="field-label">Password</div>
                <div class="field-value">
                    <smart-password-text-box #passwordtextbox select-all-on-focus placeholder="Password"
                    id="password-validation"></smart-password-text-box>
                </div>
            </div>
            <div class="field">
                <div class="field-label">Confirm Password</div>
                <div class="field-value">
                    <smart-password-text-box #passwordtextbox2 select-all-on-focus placeholder="Confirm Password"
                    id="confirm-password-validation"></smart-password-text-box>
                </div>
            </div>
        </div>
        <div class="fieldset clear">
            <div class="fieldset-header">Personal Data</div>
            <div class="field">
                <div class="field-label">Name</div>
                <div class="field-value">
                    <smart-text-box #textbox2 select-all-on-focus placeholder="Name" id="name-validation"></smart-text-box>
                </div>
            </div>
            <div class="field">
                <div class="field-label">Date of birth</div>
                <div class="field-value">
                    <smart-date-time-picker #datetimepicker format-string="dddd, MMM dd, yyyy"
                    calendar-button enable-mouse-wheel-action drop-down-position="bottom" id="date-validation"
                    spin-buttons spin-buttons-position="left"></smart-date-time-picker>
                </div>
            </div>
        </div>
        <div class="fieldset">
            <div class="fieldset-header">Billing address</div>
            <div class="field">
                <div class="field-label">Country</div>
                <div class="field-value">
                    <smart-drop-down-list #dropdownlist id="country-validation">
                        <smart-list-item value="Australia">Australia</smart-list-item>
                        <smart-list-item value="Bulgaria">Bulgaria</smart-list-item>
                        <smart-list-item value="Canada">Canada</smart-list-item>
                    </smart-drop-down-list>
                </div>
            </div>
            <div class="field">
                <div class="field-label">City</div>
                <div class="field-value">
                    <smart-text-box #textbox3 select-all-on-focus placeholder="City" id="city-validation"></smart-text-box>
                </div>
            </div>
            <div class="field">
                <div class="field-label">Address</div>
                <div class="field-value">
                    <smart-text-box #textbox4 select-all-on-focus placeholder="Address" id="address-validation"></smart-text-box>
                </div>
            </div>
            <div class="field">
                <div class="field-label">Phone (optional)</div>
                <div class="field-value">
                    <smart-masked-text-box #maskedtextbox class="material" hint="" mask="+1 (###) ###-####"
                    id="phone-validation"></smart-masked-text-box>
                </div>
            </div>
            <div class="field clear">
                <div class="field-label">Post code (optional)</div>
                <div class="field-value">
                    <smart-numeric-text-box #numerictextbox id="post-code-validation" input-format="integer"
                    min="0" spin-buttons spin-buttons-position="right" spin-buttons-step="1"
                    enable-mouse-wheel-action></smart-numeric-text-box>
                </div>
            </div>
            <div id="check" class="checkbox-validator clear">
                <smart-check-box #checkbox click-mode="press" id="termsInput">Accept terms</smart-check-box>
                <br />
            </div>
        </div>
        <div class="fieldset">
            <div id="registerButton" class="submit-button">
                <smart-button #button id="register" type="button" class="success">Register</smart-button>
            </div>
        </div>
    </form>
    <div id="validationsummary"></div>
</div>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put ValidatorModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put ValidatorModule from smart-webcomponents-angular/validator on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ValidatorModule } from 'smart-webcomponents-angular/validator';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, ValidatorModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The Validator component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Validator Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/validator/overview/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import React from "react";
import ReactDOM from 'react-dom/client';
import { Button } from 'smart-webcomponents-react/button';
import { CheckBox } from 'smart-webcomponents-react/checkbox';
import { DateTimePicker } from 'smart-webcomponents-react/datetimepicker';
import { DropDownList, ListItem, ListItemsGroup } from 'smart-webcomponents-react/dropdownlist';
import { MaskedTextBox } from 'smart-webcomponents-react/maskedtextbox';
import { NumericTextBox } from 'smart-webcomponents-react/numerictextbox';
import { PasswordTextBox } from 'smart-webcomponents-react/passwordtextbox';
import { TextBox } from 'smart-webcomponents-react/textbox';
import 'smart-webcomponents-react/source/modules/smart.validator';

class App extends React.Component {

	componentDidMount() {
		let maxDate = new Date();
		maxDate.setFullYear(2025);
		const rules = [
			//Email
			{
				input: '#email-validation',
				message: 'E-mail is required',
				action: 'keyup, blur',
				type: 'required'
			},
			{
				input: '#email-validation',
				message: 'Email is invalid',
				action: 'keyup',
				type: 'email'
			},
			//Password
			{
				input: '#password-validation',
				message: 'Password is required!',
				action: 'keyup, blur',
				type: 'required'
			},
			//Confirm password
			{
				input: '#confirm-password-validation',
				message: 'Confirm Password is required!',
				action: 'keyup, blur',
				type: 'required'
			},
			{
				input: '#confirm-password-validation',
				message: '\'Password\' and \'Confirm Password\' do not match.',
				action: 'keyup, blur',
				type: 'compare',
				comparisonTarget: function () {
					let password = document.querySelector('#password-validation');
					if (password) {
						return password.value;
					}
				},
			},
			//Name
			{
				input: '#name-validation',
				message: 'Name is required!',
				action: 'keyup, blur',
				type: 'required'
			},
			{
				input: '#name-validation',
				message: 'Do not use digits in the Name.',
				action: 'keyup, blur',
				type: 'pattern',
				pattern: /^[^0-9]+$/
			},
			{
				input: '#name-validation',
				message: 'Name must have at least 2 symbols',
				action: 'keyup, blur',
				type: 'stringLength',
				min: 2
			},
			//Date
			//{ input: '#date-validation', message: 'Date of birth is required', action: 'change', type: 'required' },
			{
				input: '#date-validation',
				message: 'You must be at least 21 years old',
				action: 'change',
				type: 'range',
				max: maxDate,
			},
			//Country
			{
				input: '#country-validation',
				message: 'Country is required',
				action: 'change',
				type: 'required'
			},
			//City
			{
				input: '#city-validation',
				message: 'City is required',
				action: 'keyup, blur',
				type: 'required'
			},
			{
				input: '#city-validation',
				message: 'Do not use digits in the City name.',
				action: 'keyup, blur',
				type: 'pattern',
				pattern: /^[^0-9]+$/
			},
			{
				input: '#city-validation',
				message: 'City must have at least 2 symbols',
				action: 'keyup, blur',
				type: 'stringLength',
				min: 2
			},
			//Address
			{
				input: '#address-validation',
				message: 'Address is required',
				action: 'keyup, blur',
				type: 'required'
			},
			//Phone
			{
				input: '#phone-validation',
				message: 'The phone must have a correct USA phone format',
				action: 'valuechanged, blur',
				type: 'required'
			},
			//Post  code
			{
				input: '#post-code-validation',
				message: 'The post code must contains only digits',
				action: 'change',
				type: 'numeric'
			},
			{
				input: '#post-code-validation',
				message: 'The post code must have at least 4 symbols',
				action: 'change',
				type: 'stringLength',
				min: 4
			},
			//Terms
			{
				input: '#termsInput',
				message: 'You must agree to the Terms and Conditions',
				action: 'change',
				type: 'required',
			},
		];

		this.validator = new window.Smart.Utilities.Validator(rules, '#validationsummary');

	}

	handleClick() {
		this.validator.validate();
	}

	render() {
		return (
			<div>
				<div className="demo-container">
					<form id="testForm" action="./">
						<div className="fieldset">
							<div className="fieldset-header">Credentials</div>
							<div className="field">
								<div className="field-label">Email</div>
								<div className="field-value">
									<TextBox  selectAllOnFocus placeholder="Email" id="email-validation"></TextBox>
								</div>
							</div>
							<div className="field">
								<div className="field-label">Password</div>
								<div className="field-value">
									<PasswordTextBox  selectAllOnFocus placeholder="Password"
										id="password-validation"></PasswordTextBox>
								</div>
							</div>
							<div className="field">
								<div className="field-label">Confirm Password</div>
								<div className="field-value">
									<PasswordTextBox  selectAllOnFocus placeholder="Confirm Password"
										id="confirm-password-validation"></PasswordTextBox>
								</div>
							</div>
						</div>
						<div className="fieldset clear">
							<div className="fieldset-header">Personal Data</div>
							<div className="field">
								<div className="field-label">Name</div>
								<div className="field-value">
									<TextBox  selectAllOnFocus placeholder="Name" id="name-validation"></TextBox>
								</div>
							</div>
							<div className="field">
								<div className="field-label">Date of birth</div>
								<div className="field-value">
									<DateTimePicker  format-string="dddd, MMM dd, yyyy"
										calendar-button enable-mouse-wheel-action drop-down-position="bottom" id="date-validation"
										spin-buttons spin-buttons-position="left"></DateTimePicker>
								</div>
							</div>
						</div>
						<div className="fieldset">
							<div className="fieldset-header">Billing address</div>
							<div className="field">
								<div className="field-label">Country</div>
								<div className="field-value">
									<DropDownList  id="country-validation">
										<ListItem value="Australia">Australia</ListItem>
										<ListItem value="Bulgaria">Bulgaria</ListItem>
										<ListItem value="Canada">Canada</ListItem>
									</DropDownList>
								</div>
							</div>
							<div className="field">
								<div className="field-label">City</div>
								<div className="field-value">
									<TextBox  selectAllOnFocus placeholder="City" id="city-validation"></TextBox>
								</div>
							</div>
							<div className="field">
								<div className="field-label">Address</div>
								<div className="field-value">
									<TextBox  selectAllOnFocus placeholder="Address" id="address-validation"></TextBox>
								</div>
							</div>
							<div className="field">
								<div className="field-label">Phone (optional)</div>
								<div className="field-value">
									<MaskedTextBox  className="material" hint="" mask="+1 (###) ###-####"
										id="phone-validation"></MaskedTextBox>
								</div>
							</div>
							<div className="field clear">
								<div className="field-label">Post code (optional)</div>
								<div className="field-value">
									<NumericTextBox  id="post-code-validation" input-format="integer"
										min="0" spin-buttons spin-buttons-position="right" spin-buttons-step="1"
										enable-mouse-wheel-action></NumericTextBox>
								</div>
							</div>
							<div id="check" className="checkbox-validator clear">
								<CheckBox  click-mode="press" id="termsInput">Accept terms</CheckBox>
								<br />
							</div>
						</div>
						<div className="fieldset">
							<div id="registerButton" className="submit-button">
								<Button  onClick={this.handleClick.bind(this)} id="register" type="button" className="success">Register</Button>
							</div>
						</div>
					</form>
					<div id="validationsummary"></div>
				</div>
			</div>
		);
	}
}



export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Validator, ValidatorProps } from 'smart-webcomponents-react/validator';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Validator component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.